---
stages:
  - pre-commit
  - test-localstack
  - test-localstack-pro
  - test-real
  - pop-release

include:
  - project: saltstack/pop/cicd/ci-templates
    file: /lint/pre-commit-run-all.yml
  - project: saltstack/pop/cicd/ci-templates
    file: /release/pop_release.yml

pre-commit-run-all:
  image: registry.gitlab.com/saltstack/pop/cicd/containers/alpinelint:py39

variables:
  CICD_UPSTREAM_PATH: "vmware/idem/idem-aws"

.test-suite:
  services:
    - name: localstack/localstack
      alias: localstack
  variables:
    ACCT_KEY: 'nw4ZjRfNRCFWQS0C6Nau_0YvGFBownpdxDLoS3qjZq0='
    ACCT_FILE: .gitlab-ci-creds.yml.fernet
    HOSTNAME_EXTERNAL: localstack
    USE_SSL: "false"
    EDGE_PORT: 4566
    FORCE_NONINTERACTIVE: 1
  stage: test-localstack
  needs:
    - pre-commit-run-all
  script:
    - python3 -m pip install nox acct
    - acct encrypt .gitlab-ci-creds.yml --acct-key="$ACCT_KEY"
    - nox -e tests-3 -- -vv tests/integration/idem_aws/  tests/unit/idem_aws/
  artifacts:
    when: always
    paths:
      - artifacts
    reports:
      junit: artifacts/junit-report.xml
    expire_in: 30 days

# Run this on real aws
# In gitlab go to your fork of idem-aws -> Settings -> CI / CD -> Variables
# Create a File key called "CI_ACCT_FILE" that contains the contents of your encrypted fernet file
# Create a Variable key called "CI_ACCT_KEY" that contains the key for decrypting your acct file
# TODO do some before and after things, like before the entire test starts list EVERYTHING
#     When the test is over list EVERYTHING again.
#     If there were any changes to real AWS after the tests (because tests didn't clean up properly or removed stuff)
#     then explode and throw a ton of descriptive errors
.test-suite-real:
  stage: test-real
  needs:
    - pre-commit-run-all
    - tests-3.7
    - tests-3.8
    - tests-3.9
    - tests-3.10
  artifacts:
    when: always
    paths:
      - artifacts
    reports:
      junit: artifacts/junit-report.xml
    expire_in: 30 days
  image: python:3.7
  variables:
    TEST_ON_REAL_AWS: "true"
  when: manual

tests-3.7:
  extends: .test-suite
  image: python:3.7

tests-3.8:
  extends: .test-suite
  image: python:3.8

tests-3.9:
  extends: .test-suite
  image: python:3.9

tests-3.10:
  extends: .test-suite
  image: python:3.10

# In gitlab go to your fork of idem-aws -> Settings -> CI / CD -> Variables
# Create a Variable key called "CI_LOCALSTACK_API_KEY" that contains your personal localstack pro api key
# The tests that use localstack pro features will now be enabled on your personal branch
tests-pro:
  extends: .test-suite
  stage: test-localstack-pro
  image: python:3.7
  variables:
    LOCALSTACK_API_KEY: $CI_LOCALSTACK_API_KEY
  only:
    variables:
      - "$CI_LOCALSTACK_API_KEY"

tests-ec2:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/ec2/test_vpc.py tests/integration/idem_aws/states/ec2/test_security_group.py tests/integration/idem_aws/states/ec2/test_subnet.py tests/integration/idem_aws/states/ec2/test_security_group_rule.py tests/integration/idem_aws/states/ec2/test_dhcp_option.py tests/integration/idem_aws/states/ec2/test_internet_gateway.py tests/integration/idem_aws/states/ec2/test_route_table.py tests/integration/idem_aws/states/ec2/test_nat_gateway.py tests/integration/idem_aws/states/ec2/test_elastic_ip.py tests/integration/idem_aws/states/ec2/test_transit_gateway.py tests/integration/idem_aws/states/ec2/test_transit_gateway_vpc_attachment.py

tests-eks-cluster:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/eks/test_cluster.py

tests-eks-node-group:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/eks/test_addon.py tests/integration/idem_aws/states/eks/test_nodegroup.py

tests-iam:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/iam/

tests-config:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/config/


tests-cloud-watch:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/cloudwatch/

tests-elasticache:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/elasticache/

tests-rds:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/rds/

tests-guardduty:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/guardduty

tests-organizations:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/organizations/test_organization.py tests/integration/idem_aws/states/organizations/test_organization_policy.py tests/integration/idem_aws/states/organizations/test_organization_policy_attachment.py tests/integration/idem_aws/states/organizations/test_organization_unit.py

tests-cloud-trail:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/cloudtrail/

tests-dynamodb:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/dynamodb

tests-kms:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/kms

tests-sns:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/sns/

tests-lambda:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/lambda

tests-autoscaling:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/autoscaling/

tests-s3:
  extends: .test-suite-real
  script:
    - export ACCT_KEY="$CI_ACCT_KEY"
    - export ACCT_FILE="$CI_ACCT_FILE"
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/integration/idem_aws/states/s3

build-idem-cloud:
  stage: pop-release
  variables:
    CICD_SOURCE_PROJECT_NAME: $CI_PROJECT_NAME
    CICD_SOURCE_COMMIT: $CI_COMMIT_SHA
    CICD_SOURCE_GITLAB_PROJECT_PATH: $CI_PROJECT_PATH
  rules:
    - if: '$CI_COMMIT_REF_PROTECTED == "true" && $CI_PROJECT_PATH == $CICD_UPSTREAM_PATH'
      when: manual
    - if: '$CI_COMMIT_REF_PROTECTED == "true" && $CI_COMMIT_TAG != null && $CI_PROJECT_PATH == $CICD_UPSTREAM_PATH'
      when: on_success
    - when: never
  trigger:
    project: vmware/idem/idem-cloud
    strategy: depend
